"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    Object.defineProperty(o, k2, { enumerable: true, get: function() { return m[k]; } });
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
var User_1 = __importDefault(require("./user/User"));
var Request_1 = __importDefault(require("./../lib/request/Request"));
var _misc = __importStar(require("./../util/Misc"));
var I18n_1 = __importDefault(require("./../lib/i18n/I18n"));
var TranslationParser_1 = __importDefault(require("./../lib/i18n/TranslationParser"));
var FrontendSDK = /** @class */ (function () {
    function FrontendSDK() {
        // Empty constructor
    }
    FrontendSDK.prototype.getUser = function (jwt) {
        return new User_1.default(jwt);
    };
    FrontendSDK.prototype.getRequest = function (endpoint) {
        return new Request_1.default(endpoint);
    };
    Object.defineProperty(FrontendSDK.prototype, "misc", {
        get: function () {
            return _misc;
        },
        enumerable: false,
        configurable: true
    });
    FrontendSDK.prototype.getTranslator = function (lang, texts) {
        if (!lang) {
            throw new Error('Language required');
        }
        if (!texts || !Array.isArray(texts)) {
            throw new Error('Translations required');
        }
        return new I18n_1.default(lang, texts);
    };
    FrontendSDK.prototype.getTranslationParser = function (dir) {
        if (!dir || typeof dir !== 'string') {
            throw new Error('Directory required');
        }
        return new TranslationParser_1.default(dir);
    };
    FrontendSDK.getInstance = function () {
        if (!this.instance) {
            this.instance = new FrontendSDK();
        }
        return this.instance;
    };
    FrontendSDK.isValidJWT = function (jwt) {
        return User_1.default.isValidJWT(jwt);
    };
    FrontendSDK.prototype.logoutUser = function (url) {
        window.location.href = url.endsWith('/') ? url + "logout" : url + "/logout";
    };
    FrontendSDK.prototype.goToProfileSetting = function (url) {
        window.location.href = url.endsWith('/') ? url + "user/profile_settings" : url + "/user/profile_settings";
    };
    FrontendSDK.prototype.goToAccountSetting = function (url) {
        window.location.href = url.endsWith('/') ? url + "user/account_settings" : url + "/user/account_settings";
    };
    return FrontendSDK;
}());
exports.default = FrontendSDK;
//# sourceMappingURL=FrontendSDK.js.map